/***************************************************************************
 *   Copyright (C) 2005 - 2006 by                                          *
 *      Christian Muehlhaeuser, Last.fm Ltd <chris@last.fm>                *
 *      Erik Jaelevik, Last.fm Ltd <erik@last.fm>                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.          *
 ***************************************************************************/

#ifdef WIN32

#ifndef WINUTILS_H
#define WINUTILS_H

#include "common.h"

#include <QString>

#include <string>

/*************************************************************************/ /**
    A bunch of static utility functions.
******************************************************************************/
class MCEXP CWinUtils
{
public:

    /*********************************************************************/ /**
        Returns the path to the system's Program Files directory inclusive
        of trailing slash.
    **************************************************************************/
    static std::string
    GetProgramFilesPath();
	
    /*********************************************************************/ /**
        Returns true if we're running on a limited user account.
    **************************************************************************/
    static bool
    IsLimitedUser();

    /*********************************************************************/ /**
        Returns the name of the default player. "" if not found.
    **************************************************************************/
    static QString
    FindDefaultPlayer();

private:

};

#endif // WINUTILS_H

#endif // WIN32
