/***************************************************************************
 *   Copyright (C) 2005 - 2006 by                                          *
 *      Christian Muehlhaeuser, Last.fm Ltd <chris@last.fm>                *
 *      Erik Jaelevik, Last.fm Ltd <erik@last.fm>                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.          *
 ***************************************************************************/

#include "loginwidget.h"

#include <QtGui>
#include <QtCore>

#include "ui_dialogshell.h"

class LoginDialog : public QDialog
{
    Q_OBJECT

    public:
        LoginDialog(
            QWidget*          parent = 0,
            LoginWidget::Mode mode = LoginWidget::LOGIN,
            QString           defaultUser = "");

    protected slots:
        virtual void accept();

    private:
        Ui::DialogShell ui;

        LoginWidget m_loginWidget;

    private slots:

    /*********************************************************************/ /**
        Called by LoginWidget when it has finished verifying the user details
        against the server.
    **************************************************************************/
    void
    loginVerified(
        bool valid);

};
