/***************************************************************************
 *   Copyright (C) 2005 - 2006 by                                          *
 *      Christian Muehlhaeuser, Last.fm Ltd <chris@last.fm>                *
 *      Erik Jaelevik, Last.fm Ltd <erik@last.fm>                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.          *
 ***************************************************************************/

#ifndef MP3TRANSCODE_H
#define MP3TRANSCODE_H

#include <transcodeinterface.h>

#include "mpglib/interface.h"

#include <QObject>
#include <QMutex>
#include <QDebug>

class MP3Transcode : public TranscodeInterface
{
    Q_OBJECT
    Q_INTERFACES( TranscodeInterface )

    public:
        MP3Transcode();

    public slots:
        void dataAvailable( const QByteArray &buffer );
        void clearBuffers() { m_mutex.lock(); m_buffer.clear(); m_mutex.unlock(); }

    signals:
        void newData( const QByteArray &buffer );

    private:
        QByteArray m_buffer;
        QMutex m_mutex;
};

#endif
