/***************************************************************************
 *   Copyright (C) 2005 - 2006 by                                          *
 *      Christian Muehlhaeuser, Last.fm Ltd <chris@last.fm>                *
 *      Erik Jaelevik, Last.fm Ltd <erik@last.fm>                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.          *
 ***************************************************************************/

#ifndef PLAYBACK_INTERFACE_H
#define PLAYBACK_INTERFACE_H

#include <QObject>

class PlaybackInterface : public QObject
{
    public:
        virtual ~PlaybackInterface() {}

        virtual void initAudio() = 0;
        virtual float volume() = 0;

        virtual QStringList soundSystems() = 0;
        virtual QStringList devices() = 0;

    public slots:
        virtual void dataAvailable( const QByteArray &buffer ) = 0;
        virtual void clearBuffers() = 0;

        virtual void startPlayback() = 0;
        virtual void stopPlayback() = 0;

        virtual void setVolume( int volume ) = 0;

    signals:
        virtual void needData() = 0;
};

Q_DECLARE_INTERFACE( PlaybackInterface, "fm.last.Playback/1.0" )

#endif
