/***************************************************************************
 *   Copyright (C) 2005 - 2006 by                                          *
 *      Christian Muehlhaeuser, Last.fm Ltd <chris@last.fm>                *
 *      Erik Jaelevik, Last.fm Ltd <erik@last.fm>                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.          *
 ***************************************************************************/

#ifndef PLAYERCOMMANDS_H
#define PLAYERCOMMANDS_H

#include <map>

/// The commands a player plugin can send to the service
enum EPlayerCommand
{
    PCMD_START,
    PCMD_STOP,
    PCMD_PAUSE,
    PCMD_RESUME,
    PCMD_EXIT,  // only used by Service itself
    PCMD_INVALID
};

/// The responses we can send back to a player plugin
enum EPlayerResponse
{
    PRESP_OK,
    PRESP_ERROR
};

/*************************************************************************/ /**
    A structure for holding parsed commands. mCmd is the command enum value
    and mArgsMap is a key/value map holding the a=Artist&t=Track etc pairs
    where the key is the char before the equals and the value is the
    text string following it.
******************************************************************************/
class CPlayerCommand
{
public:
    EPlayerCommand              mCmd;
    std::map<char, std::string> mArgsMap;
};

#endif // PLAYERCOMMANDS_H
