/***************************************************************************
 *   Copyright (C) 2005 - 2006 by                                          *
 *      Christian Muehlhaeuser, Last.fm Ltd <chris@last.fm>                *
 *      Erik Jaelevik, Last.fm Ltd <erik@last.fm>                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.          *
 ***************************************************************************/

#ifndef RTAUDIOPLAYBACK_H
#define RTAUDIOPLAYBACK_H

#include <playbackinterface.h>
#include "rtaudio/RtAudio.h"

#include <QObject>
#include <QTimer>

class RTAudioPlayback : public PlaybackInterface
{
    Q_OBJECT
    Q_INTERFACES( PlaybackInterface )

    public:
        RTAudioPlayback();

        void initAudio();
        float volume() { return m_volume; }

        QStringList soundSystems();
        QStringList devices();

        static float m_volume;

    signals:
        void needData();

    public slots:
        void dataAvailable( const QByteArray &buffer );
        void clearBuffers();

        void startPlayback();
        void stopPlayback();

        void setVolume( int volume ) { m_volume = (float)volume / 100.0; }

    private:
        RtAudio *m_audio;
        QTimer *m_timer;

        int internalSoundCardID( int settingsID );

    private slots:
        void checkBuffer();
};

#endif
