TEMPLATE = app
DESTDIR = ../bin
TARGET = last.fm.app
OBJECTS_DIR = build
MOC_DIR = build
UI_DIR = build
LIBS += -L../bin -lLastFMTools
RC_FILE = container.rc
DEPENDPATH += libLastFMTools/
INCLUDEPATH += . lib libLastFMTools \

include(../definitions.pro.inc)

unix {
    # look for iceccd, if it is running, disable PCH as it doesn't seem to work
    # with icrcream strangely

    system( test `ps aux | grep iceccd | wc -l` -gt 1 ): CONFIG -= precompile_header
}

FORMS   = container.ui \
          settingsdialog.ui \
          settingsdialog_account.ui \
          settingsdialog_radio.ui \
          settingsdialog_scrobbling.ui \
          settingsdialog_connection.ui \
          aboutdialog.ui \
          loginwidget.ui \
          progresswidget.ui \
          confirmwidget.ui \
          addplayerdialog.ui \
          selectpluginwidget.ui \
          selectupdateswidget.ui \
          dialogshell.ui \
          deleteuserdialog.ui \
          playcontrols.ui \
          failedlogindialog.ui \
          tagdialog.ui \
          recommenddialog.ui

HEADERS = container.h \
          Loqqer.h \
          settingsdialog.h \
          crashhandler.h \
          aboutdialog.h \
          scrobbler.h \
          simplewizard.h \
          configwizard.h \
          wizardinfopage.h \
          wizardconfirmpage.h \
          wizardmediadeviceconfirmpage.h \
          wizardloginpage.h \
          wizardprogresspage.h \
          wizardselectpluginpage.h \
          wizardbootstrappage.h \
          addplayerdialog.h \
          loginwidget.h \
          updateinfogetter.h \
          componentinfo.h \
          plugininfo.h \
          appinfo.h \
          exceptions.h \
          versionnumber.h \
          lib/FileVersionInfo/FileVersionInfo.h \
          lib/KillProcess/KillProcess.h \
          autoupdater.h \
          updatewizard.h \
          wizardselectupdatespage.h \
          playerlistener.h \
          playercommandparser.h \
          playercommands.h \
          playerconnection.h \
          stopwatch.h \
          logindialog.h \
          iconshack.h \
          systray.h \
          progressframe.h \
          trayicon/trayicon.h \
          checkdirtree.h \
          deleteuserdialog.h \
          failedlogindialog.h \
          volumeslider.h \
          controlinterface.h \
          tagdialog.h \
          recommenddialog.h \
          lastfmapplication.h \
          itunesscript.h \
          macstyleoverrides.h \
          winstyleoverrides.h
           
SOURCES = main.cpp \
          Loqqer.cpp \
          container.cpp \
          settingsdialog.cpp \
          crashhandler.cpp \
          aboutdialog.cpp \
          scrobbler.cpp \
          simplewizard.cpp \
          configwizard.cpp \
          wizardinfopage.cpp \
          wizardconfirmpage.cpp \
          wizardmediadeviceconfirmpage.cpp \
          wizardloginpage.cpp \
          wizardprogresspage.cpp \
          wizardselectpluginpage.cpp \
          wizardbootstrappage.cpp \
          addplayerdialog.cpp \
          loginwidget.cpp \
          updateinfogetter.cpp \
          componentinfo.cpp \
          plugininfo.cpp \
          appinfo.cpp \
          versionnumber.cpp \
          lib/FileVersionInfo/FileVersionInfo.cpp \
          autoupdater.cpp \
          updatewizard.cpp \
          wizardselectupdatespage.cpp \
          playerlistener.cpp \
          playercommandparser.cpp \
          playerconnection.cpp \
          stopwatch.cpp \
          logindialog.cpp \
          iconshack.cpp \
          systray.cpp \
          progressframe.cpp \
          trayicon/trayicon.cpp \
          checkdirtree.cpp \
          deleteuserdialog.cpp \
          failedlogindialog.cpp \
          volumeslider.cpp \
          controlinterface.cpp \
          tagdialog.cpp \
          recommenddialog.cpp \
          lastfmapplication.cpp \
          itunesscript.cpp \
          macstyleoverrides.cpp \
          winstyleoverrides.cpp

unix:!mac {
  FORMS += wizarddialog_mac.ui \
           wizardshell_mac.ui

  SOURCES += trayicon/trayicon_x11.cpp \
             simplewizard_mac.cpp
  HEADERS += simplewizard_mac.h
}

unix:mac {
  FORMS += wizarddialog_mac.ui \
           wizardshell_mac.ui

  SOURCES += trayicon/trayicon_mac.cpp \
             simplewizard_mac.cpp
  HEADERS += simplewizard_mac.h

  ICON = ../bin/data/icons/lastfm.icns
}

win32 {
  FORMS += wizarddialog_win.ui \
           wizardextshell_win.ui \
           wizardintshell_win.ui

  LIBS += -lshfolder -luser32 -lshell32 -lversion -lWs2_32 -lGdi32

  SOURCES += trayicon/trayicon_win.cpp \
             simplewizard_win.cpp
  HEADERS += simplewizard_win.h
}

QT += gui network xml
